/**@addtogroup misc
 * @{*/

/**@addtogroup misc_types  Platform Independent Types
 *
 * The definitions here are aimed to remove to uncertainity of @c int
 * implementation. This header file should provide types with well specified
 * size and range, regardless of target platform or compiler.
 * 
 * @{*/


/**@file
 * @brief Platform independent type definitions (interface).
 * @author Petr Grillinger, University of West Bohemia, Czech Republic
 * @author Jan Jezek, University of West Bohemia, Czech Republic
 * @version 1.5
 * @date Last modified 2002-11-16
 * 
 * @note This file is part of C-Sim model of TTP/C protocol 0.1, 
 *  created as part of EU project FIT - Fault Injection for TTA, IST-1999-10748
 */


#ifndef _FL1TYPE_H
#define _FL1TYPE_H

/** Signed 32-bit integer.*/
typedef int INT32;

/** Unsigned 32-bit integer.*/
typedef unsigned UINT32;

/** Signed 16-bit integer.*/
typedef short INT16;

/** Unsigned 16-bit integer.*/
typedef unsigned short UINT16;

/** Signed 8-bit integer.*/
typedef char INT8;

/** Unsigned 8-bit integer.*/
typedef unsigned char UINT8;


#endif

/*@}*/
/*@}*/

